Gentoo Archives: gentoo-commits

From: Joonas Niilola <juippis@g.o>
To: gentoo-commits@l.g.o
Subject: [gentoo-commits] repo/gentoo:master commit in: app-editors/vim/
Date: Tue, 28 Feb 2023 14:10:59
Message-Id: 1677593382.7676e5d454467389f074f325f1c432c0cda66b53.juippis@gentoo
1 commit: 7676e5d454467389f074f325f1c432c0cda66b53
2 Author: Oskari Pirhonen <xxc3ncoredxx <AT> gmail <DOT> com>
3 AuthorDate: Thu Feb 23 03:12:16 2023 +0000
4 Commit: Joonas Niilola <juippis <AT> gentoo <DOT> org>
5 CommitDate: Tue Feb 28 14:09:42 2023 +0000
6 URL: https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=7676e5d4
7
8 app-editors/vim: add 9.0.1341
9
10 Signed-off-by: Oskari Pirhonen <xxc3ncoredxx <AT> gmail.com>
11 Signed-off-by: Joonas Niilola <juippis <AT> gentoo.org>
12
13 app-editors/vim/Manifest | 1 +
14 app-editors/vim/vim-9.0.1341.ebuild | 374 ++++++++++++++++++++++++++++++++++++
15 2 files changed, 375 insertions(+)
16
17 diff --git a/app-editors/vim/Manifest b/app-editors/vim/Manifest
18 index cc371e9489e1..56bc4f66ba32 100644
19 --- a/app-editors/vim/Manifest
20 +++ b/app-editors/vim/Manifest
21 @@ -1,3 +1,4 @@
22 DIST vim-9.0.1000.tar.gz 16842747 BLAKE2B 85edab7d13daa3e84ef0aeb50e3e9bfd31f0634d8e480c105727b0c34318e0adf7f1276dcdac53df8fc416fd8dfb70377cd74ed570752a3e77f07a083fa6c113 SHA512 9d2b914a112948d77b92c8dcafc2f711a83c3fdaf35a28f7f606e77007b9320e2260a0f6b24fc875a817c33c012f077f89730b34e9f12d6f00795c5c806704c8
23 DIST vim-9.0.1157.tar.gz 16924574 BLAKE2B 0cdc6cf61f5abdaff0762b98550bfa5bae8f0485ddd0e9947a5fe52390f9da54fc8f5fdae767fb8f5d3ac2b441253917a80ae7f6092f67b69bdc9b6a630df8e2 SHA512 19240a9bcf5900766db42e2894b1bf7b849274711f17dc267671aacd867b334c3d30f39947dde7dd0245f289e9ad801eeb272f34a2ab15d01fac40bf71a54271
24 +DIST vim-9.0.1341.tar.gz 16965673 BLAKE2B 2b58e68b06a7eb7104f77459be9ea202d979e3daae02073db29f24a07e20152c1f9f7f380e7569ab56ceef174658081bdde06db253827684d0731afb2f3fbbc6 SHA512 48e5232d629ccc9ee0093061d5340181083e22ff6b4eb0ad2e979a92be9c2a47b640ca1a58812da0f79a736f4b406a2541eb8fa4accd8213cf6ee9df1cd7f4fc
25 DIST vim-patches-vim-9.0.1000-patches.tar.bz2 3245 BLAKE2B 3bf3d0e314cc3f96d5d9675de196a62c4c8a72645d56ef94b80768571c99cba5cc556442e3bd2dfa8818460fd851fe7bd1ae15999af7225fb271b81c43105843 SHA512 2883441a2001bf7ce89a7f0862f780b71cc0164c8fcb8dbdf7040e1bcbcf408d138d3d77f308aa54c762e9975fa5ec89cfceeabbf721344dfc938870a363667a
26
27 diff --git a/app-editors/vim/vim-9.0.1341.ebuild b/app-editors/vim/vim-9.0.1341.ebuild
28 new file mode 100644
29 index 000000000000..40a78fc412a4
30 --- /dev/null
31 +++ b/app-editors/vim/vim-9.0.1341.ebuild
32 @@ -0,0 +1,374 @@
33 +# Copyright 1999-2023 Gentoo Authors
34 +# Distributed under the terms of the GNU General Public License v2
35 +
36 +EAPI=8
37 +
38 +# Please bump with app-editors/vim-core and app-editors/gvim
39 +
40 +VIM_VERSION="9.0"
41 +VIM_PATCHES_VERSION="9.0.1000"
42 +
43 +LUA_COMPAT=( lua5-{1..4} luajit )
44 +PYTHON_COMPAT=( python3_{9..11} )
45 +PYTHON_REQ_USE="threads(+)"
46 +USE_RUBY="ruby27 ruby30 ruby31"
47 +
48 +inherit vim-doc flag-o-matic bash-completion-r1 lua-single python-single-r1 ruby-single toolchain-funcs desktop xdg-utils
49 +
50 +if [[ ${PV} == 9999* ]] ; then
51 + inherit git-r3
52 + EGIT_REPO_URI="https://github.com/vim/vim.git"
53 +else
54 + SRC_URI="https://github.com/vim/vim/archive/v${PV}.tar.gz -> ${P}.tar.gz
55 + https://gitweb.gentoo.org/proj/vim-patches.git/snapshot/vim-patches-vim-${VIM_PATCHES_VERSION}-patches.tar.bz2"
56 + KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~loong ~m68k ~mips ~ppc ~ppc64 ~riscv ~s390 ~sparc ~x86 ~x64-cygwin ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
57 +fi
58 +
59 +DESCRIPTION="Vim, an improved vi-style text editor"
60 +HOMEPAGE="https://www.vim.org https://github.com/vim/vim"
61 +
62 +LICENSE="vim"
63 +SLOT="0"
64 +IUSE="X acl crypt cscope debug gpm lua minimal nls perl python racket ruby selinux sound tcl terminal vim-pager"
65 +REQUIRED_USE="
66 + lua? ( ${LUA_REQUIRED_USE} )
67 + python? ( ${PYTHON_REQUIRED_USE} )
68 + vim-pager? ( !minimal )
69 +"
70 +
71 +RDEPEND="
72 + >=app-eselect/eselect-vi-1.1
73 + >=sys-libs/ncurses-5.2-r2:0=
74 + nls? ( virtual/libintl )
75 + acl? ( kernel_linux? ( sys-apps/acl ) )
76 + crypt? ( dev-libs/libsodium:= )
77 + cscope? ( dev-util/cscope )
78 + gpm? ( >=sys-libs/gpm-1.19.3 )
79 + lua? ( ${LUA_DEPS}
80 + $(lua_gen_impl_dep 'deprecated' lua5-1)
81 + )
82 + ~app-editors/vim-core-${PV}
83 + !<app-editors/vim-core-8.2.4328-r1
84 + vim-pager? ( app-editors/vim-core[-minimal] )
85 + perl? ( dev-lang/perl:= )
86 + python? ( ${PYTHON_DEPS} )
87 + racket? ( dev-scheme/racket )
88 + ruby? ( ${RUBY_DEPS} )
89 + selinux? ( sys-libs/libselinux )
90 + sound? ( media-libs/libcanberra )
91 + tcl? ( dev-lang/tcl:0= )
92 + X? ( x11-libs/libXt )
93 +"
94 +DEPEND="${RDEPEND}"
95 +# configure runs the Lua interpreter
96 +BDEPEND="
97 + sys-devel/autoconf
98 + lua? ( ${LUA_DEPS} )
99 + nls? ( sys-devel/gettext )
100 +"
101 +PDEPEND="!minimal? ( app-vim/gentoo-syntax )"
102 +
103 +if [[ ${PV} != 9999* ]]; then
104 + # Gentoo patches to fix runtime issues, cross-compile errors, etc
105 + PATCHES=(
106 + "${WORKDIR}/vim-patches-vim-${VIM_PATCHES_VERSION}-patches"
107 + )
108 +fi
109 +
110 +pkg_setup() {
111 + # people with broken alphabets run into trouble. bug #82186.
112 + unset LANG LC_ALL
113 + export LC_COLLATE="C"
114 +
115 + use lua && lua-single_pkg_setup
116 + use python && python-single-r1_pkg_setup
117 +}
118 +
119 +src_prepare() {
120 + default
121 +
122 + # Fixup a script to use awk instead of nawk
123 + sed -i -e \
124 + '1s|.*|#!'"${EPREFIX}"'/usr/bin/awk -f|' \
125 + "${S}"/runtime/tools/mve.awk || die "mve.awk sed failed"
126 +
127 + # Read vimrc and gvimrc from /etc/vim
128 + echo '#define SYS_VIMRC_FILE "'${EPREFIX}'/etc/vim/vimrc"' \
129 + >> "${S}"/src/feature.h || die "echo failed"
130 + echo '#define SYS_GVIMRC_FILE "'${EPREFIX}'/etc/vim/gvimrc"' \
131 + >> "${S}"/src/feature.h || die "echo failed"
132 +
133 + # Use exuberant ctags which installs as /usr/bin/exuberant-ctags.
134 + # Hopefully this pattern won't break for a while at least.
135 + # This fixes bug #29398 (27 Sep 2003 agriffis)
136 + sed -i -e \
137 + 's/\<ctags\("\| [-*.]\)/exuberant-&/g' \
138 + "${S}"/runtime/doc/syntax.txt \
139 + "${S}"/runtime/doc/tagsrch.txt \
140 + "${S}"/runtime/doc/usr_29.txt \
141 + "${S}"/runtime/menu.vim \
142 + "${S}"/src/configure.ac || die 'sed failed'
143 +
144 + # Don't be fooled by /usr/include/libc.h. When found, vim thinks
145 + # this is NeXT, but it's actually just a file in dev-libs/9libs
146 + # This fixes bug #43885 (20 Mar 2004 agriffis)
147 + sed -i -e \
148 + 's/ libc\.h / /' \
149 + "${S}"/src/configure.ac || die 'sed failed'
150 +
151 + # gcc on sparc32 has this, uhm, interesting problem with detecting EOF
152 + # correctly. To avoid some really entertaining error messages about stuff
153 + # which isn't even in the source file being invalid, we'll do some trickery
154 + # to make the error never occur. bug 66162 (02 October 2004 ciaranm)
155 + find "${S}" -name '*.c' | while read c; do
156 + echo >> "$c" || die "echo failed"
157 + done
158 +
159 + # conditionally make the manpager.sh script
160 + if use vim-pager; then
161 + cat > "${S}"/runtime/macros/manpager.sh <<-_EOF_ || die "cat EOF failed"
162 + #!/bin/sh
163 + sed -e 's/\x1B\[[[:digit:]]\+m//g' | col -b | \\
164 + vim \\
165 + -c 'let no_plugin_maps = 1' \\
166 + -c 'set nolist nomod ft=man ts=8' \\
167 + -c 'let g:showmarks_enable=0' \\
168 + -c 'runtime! macros/less.vim' -
169 + _EOF_
170 + fi
171 +
172 + # Try to avoid sandbox problems. Bug #114475.
173 + if [[ -d "${S}"/src/po ]]; then
174 + sed -i -e \
175 + '/-S check.vim/s,..VIM.,ln -s $(VIM) testvim \; ./testvim -X,' \
176 + "${S}"/src/po/Makefile || die "sed failed"
177 + fi
178 +
179 + cp -v "${S}"/src/config.mk.dist "${S}"/src/auto/config.mk || die "cp failed"
180 +
181 + sed -i -e \
182 + "s:\\\$(PERLLIB)/ExtUtils/xsubpp:${EPREFIX}/usr/bin/xsubpp:" \
183 + "${S}"/src/Makefile || die 'sed for ExtUtils-ParseXS failed'
184 +
185 + # Fix bug 18245: Prevent "make" from the following chain:
186 + # (1) Notice configure.ac is newer than auto/configure
187 + # (2) Rebuild auto/configure
188 + # (3) Notice auto/configure is newer than auto/config.mk
189 + # (4) Run ./configure (with wrong args) to remake auto/config.mk
190 + sed -i 's# auto/config\.mk:#:#' src/Makefile || die "Makefile sed failed"
191 + rm src/auto/configure || die "rm failed"
192 +}
193 +
194 +src_configure() {
195 +
196 + # Fix bug #37354: Disallow -funroll-all-loops on amd64
197 + # Bug #57859 suggests that we want to do this for all archs
198 + filter-flags -funroll-all-loops
199 +
200 + # Fix bug 76331: -O3 causes problems, use -O2 instead. We'll do this for
201 + # everyone since previous flag filtering bugs have turned out to affect
202 + # multiple archs...
203 + replace-flags -O3 -O2
204 +
205 + emake -j1 -C src autoconf
206 +
207 + # This should fix a sandbox violation (see bug #24447). The hvc
208 + # things are for ppc64, see bug #86433.
209 + for file in /dev/pty/s* /dev/console /dev/hvc/* /dev/hvc*; do
210 + if [[ -e "${file}" ]]; then
211 + addwrite ${file}
212 + fi
213 + done
214 +
215 + local myconf=()
216 + if use minimal; then
217 + myconf=(
218 + --with-features=tiny
219 + --disable-nls
220 + --disable-canberra
221 + --disable-acl
222 + --enable-gui=no
223 + --without-x
224 + --disable-darwin
225 + --disable-luainterp
226 + --disable-perlinterp
227 + --disable-pythoninterp
228 + --disable-mzschemeinterp
229 + --disable-rubyinterp
230 + --disable-selinux
231 + --disable-tclinterp
232 + --disable-gpm
233 + )
234 + else
235 + use debug && append-flags "-DDEBUG"
236 +
237 + myconf=(
238 + --with-features=huge
239 + $(use_enable sound canberra)
240 + $(use_enable acl)
241 + $(use_enable crypt libsodium)
242 + $(use_enable cscope)
243 + $(use_enable gpm)
244 + $(use_enable nls)
245 + $(use_enable perl perlinterp)
246 + $(use_enable python python3interp)
247 + $(use_with python python3-command "${PYTHON}")
248 + $(use_enable racket mzschemeinterp)
249 + $(use_enable ruby rubyinterp)
250 + $(use_enable selinux)
251 + $(use_enable tcl tclinterp)
252 + $(use_enable terminal)
253 + )
254 +
255 + # --with-features=huge forces on cscope even if we --disable it. We need
256 + # to sed this out to avoid screwiness. (1 Sep 2004 ciaranm)
257 + if ! use cscope; then
258 + sed -i -e \
259 + '/# define FEAT_CSCOPE/d' src/feature.h || die "sed failed"
260 + fi
261 +
262 + if use lua; then
263 + # -DLUA_COMPAT_OPENLIB=1 is required to enable the
264 + # deprecated (in 5.1) luaL_openlib API (#874690)
265 + use lua_single_target_lua5-1 && append-cppflags -DLUA_COMPAT_OPENLIB=1
266 +
267 + myconf+=(
268 + --enable-luainterp
269 + $(use_with lua_single_target_luajit luajit)
270 + --with-lua-prefix="${EPREFIX}/usr"
271 + )
272 + fi
273 +
274 + # don't test USE=X here ... see bug #19115
275 + # but need to provide a way to link against X ... see bug #20093
276 + myconf+=(
277 + --enable-gui=no
278 + --disable-darwin
279 + $(use_with X x)
280 + )
281 + fi
282 +
283 + # let package manager strip binaries
284 + export ac_cv_prog_STRIP="$(type -P true ) faking strip"
285 +
286 + # keep prefix env contained within the EPREFIX
287 + use prefix && myconf+=( --without-local-dir )
288 +
289 + if tc-is-cross-compiler ; then
290 + export vim_cv_getcwd_broken=no \
291 + vim_cv_memmove_handles_overlap=yes \
292 + vim_cv_stat_ignores_slash=yes \
293 + vim_cv_terminfo=yes \
294 + vim_cv_toupper_broken=no
295 + fi
296 +
297 + econf \
298 + --with-modified-by=Gentoo-${PVR} \
299 + "${myconf[@]}"
300 +}
301 +
302 +src_compile() {
303 + # The following allows emake to be used
304 + emake -j1 -C src auto/osdef.h objects
305 +
306 + emake
307 +}
308 +
309 +src_test() {
310 + einfo
311 + einfo "Starting vim tests. Several error messages will be shown"
312 + einfo "while the tests run. This is normal behaviour and does not"
313 + einfo "indicate a fault."
314 + einfo
315 + ewarn "If the tests fail, your terminal may be left in a strange"
316 + ewarn "state. Usually, running 'reset' will fix this."
317 + einfo
318 +
319 + # Don't let vim talk to X
320 + unset DISPLAY
321 +
322 + # Arch and opensuse seem to do this and at this point, I'm willing
323 + # to try anything to avoid random test hangs!
324 + export TERM=xterm
325 +
326 + # See https://github.com/vim/vim/blob/f08b0eb8691ff09f98bc4beef986ece1c521655f/src/testdir/runtest.vim#L5
327 + # for more information on test variables we can use.
328 + # Note that certain variables need vim-compatible regex (not PCRE), see e.g.
329 + # http://www.softpanorama.org/Editors/Vimorama/vim_regular_expressions.shtml.
330 + #
331 + # Skipped tests:
332 + # - Test_expand_star_star
333 + # Hangs because of a recursive symlink in /usr/include/nodejs (bug #616680)
334 + # - Test_exrc
335 + # Looks in wrong location? (bug #742710)
336 + # - Test_job_tty_in_out
337 + # Fragile and depends on TERM(?)
338 + # - Test_spelldump_bang
339 + # Hangs.
340 + # - Test_fuzzy_completion_env
341 + # Too sensitive to leaked environment variables.
342 + # - Test_term_mouse_multiple_clicks_to_select_mode
343 + # Hangs.
344 + # - Test_spelldump
345 + # Hangs.
346 + export TEST_SKIP_PAT='\(Test_expand_star_star\|Test_exrc\|Test_job_tty_in_out\|Test_spelldump_bang\|Test_fuzzy_completion_env\|Test_term_mouse_multiple_clicks_to_select_mode\|Test_spelldump\)'
347 +
348 + emake -j1 -C src/testdir nongui
349 +}
350 +
351 +# Call eselect vi update with --if-unset
352 +# to respect user's choice (bug #187449)
353 +eselect_vi_update() {
354 + ebegin "Calling eselect vi update"
355 + eselect vi update --if-unset
356 + eend $?
357 +}
358 +
359 +src_install() {
360 + local vimfiles=/usr/share/vim/vim${VIM_VERSION/.}
361 +
362 + # Note: Do not install symlinks for 'vi', 'ex', or 'view', as these are
363 + # managed by eselect-vi
364 + dobin src/vim
365 + if ! use minimal ; then
366 + dosym vim /usr/bin/vimdiff
367 + fi
368 + dosym vim /usr/bin/rvim
369 + dosym vim /usr/bin/rview
370 + if use vim-pager ; then
371 + dosym ${vimfiles}/macros/less.sh /usr/bin/vimpager
372 + dosym ${vimfiles}/macros/manpager.sh /usr/bin/vimmanpager
373 + insinto ${vimfiles}/macros
374 + doins runtime/macros/manpager.sh
375 + fperms a+x ${vimfiles}/macros/manpager.sh
376 + fi
377 +
378 + domenu runtime/vim.desktop
379 +
380 + newbashcomp "${FILESDIR}"/${PN}-completion ${PN}
381 +
382 + # keep in sync with 'complete ... -F' list
383 + bashcomp_alias vim ex vi view rvim rview vimdiff
384 +}
385 +
386 +pkg_postinst() {
387 + # Update documentation tags (from vim-doc.eclass)
388 + update_vim_helptags
389 +
390 + # Call eselect vi update
391 + eselect_vi_update
392 +
393 + # update desktop file mime cache
394 + xdg_desktop_database_update
395 +}
396 +
397 +pkg_postrm() {
398 + # Update documentation tags (from vim-doc.eclass)
399 + update_vim_helptags
400 +
401 + # Call eselect vi update
402 + eselect_vi_update
403 +
404 + # update desktop file mime cache
405 + xdg_desktop_database_update
406 +}